#include <stdio.h>
#include "pico/stdlib.h"
#include "hardware/gpio.h"
#include "../xiao_rp2040.h"

const uint PIN_LED = D7;

void my_pwm(uint pin, uint frequency, double duty_cycle) {
  uint period_us = 1000000 / frequency;
  uint period_on_us = floor(duty_cycle * period_us);
  uint period_off_us = floor((1 - duty_cycle) * period_us);

  while (1) {
    gpio_put(pin, 1);
    sleep_us(period_on_us);
    gpio_put(pin, 0);
    sleep_us(period_off_us);
  }
}

int main() {
  stdio_init_all();

  gpio_init(PIN_LED);
  gpio_set_dir(PIN_LED, GPIO_OUT);

  my_pwm(PIN_LED, 100, 0.05);
}
