#include <stdio.h>
#include "pico/stdlib.h"
#include "hardware/gpio.h"
#include "../xiao_rp2040.h"

const uint PIN_LED = D7;

int main() {
  stdio_init_all();

  gpio_init(PIN_LED);
  gpio_set_dir(PIN_LED, GPIO_OUT);

  uint64_t start = time_us_64();
  for (int i = 0; i < 1000000; i++) {
    gpio_put(PIN_LED, 1);
    sleep_us(1);
    gpio_put(PIN_LED, 0);
    sleep_us(1);
  }
  uint64_t end = time_us_64();

  // wait for the IO terminal to be available
  sleep_ms(3000);

  printf("100000 iterations took %lld us\n", end - start);

  while (true) {
    tight_loop_contents();
  }
}
