#include <stdio.h>
#include "pico/stdlib.h"
#include "hardware/gpio.h"
#include "../xiao_rp2040.h"

const uint PIN_BUZZER = D8;

void my_pwm(uint pin, uint frequency, double duty_cycle, uint duration_ms) {
  uint period_us = 1000000 / frequency;
  uint period_on_us = floor(duty_cycle * period_us);
  uint period_off_us = floor((1 - duty_cycle) * period_us);
  uint nr_iterations = floor((1000 * duration_ms) / period_us);
  for (int i = 0; i < nr_iterations; i++) {
    gpio_put(pin, 1);
    sleep_us(period_on_us);
    gpio_put(pin, 0);
    sleep_us(period_off_us);
  }
}

#define A 440
#define E 330
#define F 349
#define GIS 415

void note(uint note, uint duration_ms, uint rest_ms) {
  my_pwm(PIN_BUZZER, note, 0.5, duration_ms);
  sleep_ms(rest_ms);
}

void rest(uint duration_ms) {
  sleep_ms(duration_ms);
}

void song() {
  note(A, 300, 200);
  note(E, 230, 100);
  note(E, 110, 50);
  
  note(F, 300, 200);
  note(E, 300, 200);
  rest(500);
  note(GIS, 300, 200);
  note(A, 300, 200);
  rest(500);
}

int main() {
  stdio_init_all();

  gpio_init(PIN_BUZZER);
  gpio_set_dir(PIN_BUZZER, GPIO_OUT);

  while (1) {
    song();
  }
}
